%define name php
%define ver  3.0.18
%define ext  i18n_ja_2
%define rel  10jaJPml

%define ORACLE 1
%{!?ORACLE:%define ORACLE 0}
%if %{ORACLE}
%define ORACLE_HOME /u01/app/oracle/product/8.1.6
%endif

%if %{FHS}
%define manualdir /var/www/html/manual/mod/mod_php3
%define libdir /usr/lib/apache
%else
%define manualdir /home/httpd/html/manual/mod/mod_php3
%define libdir /usr/libexec/apache
Serial: 2002030101
%endif

%define mysql 1
%{!?mysql:%define mysql 0}

Summary: The PHP HTML-embedded scripting language for use with Apache.
Name: %{name}
Version: %{ver}_%{ext}
Release: %{rel}
Group: System Environment/Daemons
#Source: http://www.php.net/distributions/php-%{version}.tar.gz
Source0: http://php.vdomains.org/php-3.0.18-i18n-ja-2.tar.gz
Source1: FAQ.php3
Source2: php3_pb.png
Source3: php3_test.php3 
Source4: pg_test.php3
Source5: pg_test.table
Source6: libdumy.c
Patch:    php-%{version}.patch
Patch1: php-3.0.18.add_extension.patch
Patch2: php-3.0.18.php3ini.patch
Patch3: php-3.0.18.popen.patch
%if %{FHS}
Patch4: php-3.0.18.extension_dir.patch
%endif
Patch5: php-3.0.18-i18n-ja-2-mime.patch
Patch6: php-3.0.18-i18n-ja-2-display.patch
Copyright: GPL
BuildRoot: /var/tmp/%{name}-root
Requires: apache
PreReq: perl,apache
BuildRequires: apache-devel,postgresql-devel,openldap-devel,imap-devel >= 4.7
%if %{mysql}
%if %{FHS}
BuildRequires: mysql-devel
%else
BuildRequires: MySQL-devel
%endif
%endif
Obsoletes: mod_php3

%description
PHP is an HTML-embedded scripting language.  PHP attempts to make it
easy for developers to write dynamically generated web pages.  PHP
also offers built-in database integration for several commercial and
non-commercial database management systems, so writing a
database-enabled web page with PHP is fairly simple.  The most common
use of PHP coding is probably as a replacement for CGI scripts.  The
mod_php module enables the Apache web server to understand and process
the embedded PHP language in web pages.

This package contains PHP.  If you use applications which specifically
rely on PHP/FI (PHP v2 and earlier), you should instead
install the PHP/FI module contained in the phpfi package.  If you're
just starting with PHP, you should install this package.  You'll also
need to install the Apache web server.

%package manual
Group: System Environment/Daemons
Summary: On-line manual for PHP3

%description manual
Comprehensive documentation for PHP3, viewable through any web
browser.

%package pgsql
Group: System Environment/Daemons
Requires: php,postgresql
prereq: /usr/bin/perl
Summary: PostgreSQL database module for PHP3.

%description pgsql
this is a dynamic shared object (DSO) for Apache that will add PostgreSQL
database support to PHP3.  If you need back-end support for PostgreSQL,
you should install this package in addition to the main php package.

%package imap
Group: System Environment/Daemons
Requires: php
Prereq: /usr/bin/perl
Summary: IMAP module for PHP3.

%description imap
This is a dynamic shared object (DSO) for Apache that will add IMAP
support to PHP3.  If you need to have IMAP support for PHP3 applications,
you will need to install this package in addition to the main php
package.

%package ldap
Group: System Environment/Daemons
%if %{FHS}
Requires: php,openldap
%else
Requires: php,openldap-libs
%endif
Prereq: /usr/bin/perl
Summary: LDAP directory module for PHP3.

%description ldap
This is a dynamic shared object (DSO) for Apache that will add LDAP
support to PHP3.  If you need to have LDAP support for PHP3 applications,
you will need to install this package in addition to the main php
package.

%package mysql
Group: System Environment/Daemons
%if %{FHS}
Requires: php,mysql
%else
Requires: php,MySQL
%endif
Prereq: /usr/bin/perl
Summary: MySQL database module for PHP3.

%description mysql
this is a dynamic shared object (DSO) for Apache that will add MySQL
database support to PHP3.  If you need back-end support for MySQL,
you should install this package in addition to the main php package.


%package oracle
Group: System Environment/Daemons
Requires: php
Prereq: /usr/bin/perl
Summary: Oracle DB module for PHP3.

%description oracle
This is a dynamic shared object (DSO) for Apache that will add ORACLE
support to PHP3.  If you need to have ORACLE support for PHP3 applications,
you will need to install this package in addition to the main php
package.

%changelog
* Fri Mar  1 2002 Noboru Higuchi <nhiguchi@miraclelinux.com>
- Add php-3.0.18-i18n-ja-2-mime.patch for security update
- Add php-3.0.18-i18n-ja-2-display.patch for security update
- Add MySQL for MLSE V1.1

* Fri Sep 28 2001 Tetsuya Matsuzaki <tmatsuza@miraclelinux.com>
- support mysql (MySQL -> mysql)

* Thu Sep 6 2001 Tetsuya Matsuzaki <tmatsuza@miraclelinux.com>
- config libdir option (/usr/lib/apache)
- extension_dir path (/usr/lib/apache)

* Tue Aug 21 2001 Tetsuya Matsuzaki <tmatsuza@miraclelinux.com>
- for FHS
- add config option mysql

* Tue Mar 6 2001 Tatsuo Ito <tito@miraclelinux.com>
- 3.0.18-i18n-ja_2-7jaJP
- add --enable-sigchild configure flag for oracle
- make the popen patch : The system() and exec() for php function return 
  correct value.

* Thu Feb 1 2001 Tatsuo Ito <tito@miraclelinux.com>
- make the character of pg_test.table EUC.

* Mon Jan 29 2001 Tatsuo Ito <tito@miraclelinux.com>
- remove --enable-sigchild for configure:
  If add this option, php's function, exec() and system(),
  return -1 always.

* Fri Jan 26 2001 Tatsuo Ito <tito@miraclelinux.com>
- modify pg_test.php3 and pg_test.table

* Wed Jan 24 2001 Tatsuo Ito <tito@miraclelinux.com>
- bug fix for spec: %if ORACLE -> %if %{ORACLE}

* Wed Jan 10 2001 Tatsuo Ito <tito@miraclelinux.com>
- 3.0.18_i18n_ja_2-1jaJP
- add --enable-sigchild for configure

* Tue Aug  1 2000 Go Taniguchi <go@turbolinux.co.jp>
- support oracle

* Thu May 18 2000 Toshihiro Yamagishi<toshihiro@turbolinux.co.jp>
- erase httpd.conf.bak

* Mon May  8 2000 Toshihiro Yamagishi<toshihiro@turbolinux.co.jp>
- added MySQL support
- added compile option "-DEAPI" of modules

* Fri Apr 21 2000 Toshihiro Yamagishi<toshihiro@turbolinux.co.jp>
- delete gd support

* Wed Apr 19 2000 Kazuhiro Taga <tagache@turbolinux.co.jp>
- fixed spec file for ORACLE (orignal by toshihiro@turbolinux.co.jp)

* Wed Apr 19 2000 Kazuhiro Taga <tagache@turbolinux.co.jp>
- Added Compile option "-DEAPI"
- Updated php to 3.0.15-i18n-ja

* Tue Mar 21 2000 Kazuhiro Taga <tagache@turbolinux.co.jp>
- created Test program for PHP3 + PostgreSQL

* Tue Mar 17 2000 Kazuhiro Taga <tagache@turbolinux.co.jp>
- Update php to 3.0.14-i18n-ja (+ imap)

* Tue Mar  7 2000 Kazuhiro Taga <tagache@turbolinux.co.jp>
- Build for TurboLlinux Workstation 6.0
- Update php to 3.0.14-i18n-ja (+ postgreSQL)

* Fri Sep 24 1999 Preston Brown <pbrown@redhat.com>
- --with-apxs --> --with-apxs=/usr/sbin/apxs (# 5094)
- ldap support (# 5097)

* Thu Sep 23 1999 Preston Brown <pbrown@redhat.com>
- fix cmdtuples for postgresql, I had it slightly wrong

* Tue Aug 31 1999 Bill Nottingham <notting@redhat.com>
- subpackages must obsolete old stuff...

* Sun Aug 29 1999 Preston Brown <pbrown@redhat.com>
- added -DHAVE_PGCMDTUPLES for postgresql module (bug # 4767)

* Fri Aug 27 1999 Preston Brown <pbrown@redhat.com>
- name change to php to follow real name of package
- fix up references to php3 to refer to php
- upgrade to 3.0.12
- fixed typo in pgsql postun script (bug # 4686)

* Mon Jun 14 1999 Preston Brown <pbrown@redhat.com>
- upgraded to 3.0.9
- fixed postgresql module and made separate package
- separated manual into separate documentation package

* Mon May 24 1999 Preston Brown <pbrown@redhat.com>
- upgraded to 3.0.8, which fixes problems with glibc 2.1.
- took some ideas grom Gomez's RPM.

* Tue May 04 1999 Preston Brown <pbrown@redhat.com>
- hacked in imap support in an ugly way until imap gets an official
  shared library implementation

* Fri Apr 16 1999 Preston Brown <pbrown@redhat.com>
- pick up php3.ini

* Wed Mar 24 1999 Preston Brown <pbrown@redhat.com>
- build against apache 1.3.6

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com> 
- auto rebuild in the new build environment (release 2)

* Mon Mar 08 1999 Preston Brown <pbrown@redhat.com>
- upgraded to 3.0.7.

* Wed Feb 24 1999 Preston Brown <pbrown@redhat.com>
- Injected new description and group.

* Sun Feb 07 1999 Preston Brown <pbrown@redhat.com>
- upgrade to php 3.0.6, built against apache 1.3.4

* Mon Oct 12 1998 Cristian Gafton <gafton@redhat.com>
- rebuild for apache 1.3.3

* Thu Oct 08 1998 Preston Brown <pbrown@redhat.com>
- updated to 3.0.5, fixes nasty bugs in 3.0.4.

* Sun Sep 27 1998 Cristian Gafton <gafton@redhat.com>
- updated to 3.0.4 and recompiled for apache 1.3.2

* Thu Sep 03 1998 Preston Brown <pbrown@redhat.com>
- improvements; builds with apache-devel package installed.

* Tue Sep 01 1998 Preston Brown <pbrown@redhat.com>
- Made initial cut for PHP3.

%prep
%setup -q -n php-3.0.18-i18n-ja-2
%patch -p1 -b .config
%patch1 -p1 -b .add
%patch2 -p0 -b .org
%patch3 -p1 -b .popen
%if %{FHS}
%patch4 -p0 -b .extension_dir
%endif
%patch5 -p1 -b .mime
%patch6 -p1 -b .disp

%build

autoconf
CFLAGS="-fPIC -DEAPI" ./configure --prefix=/usr \
	--with-apxs=/usr/sbin/apxs \
	--with-config-file-path=/etc/httpd \
	--enable-safe-mode \
	--with-exec-dir=/usr/bin \
	--disable-debug \
	--with-zlib \
	--without-gd \
	--without-mysql \
	--enable-debugger \
	--enable-magic-quotes \
	--enable-track-vars \
	--enable-i18n \
	--enable-mbregex \
	--enable-sigchild
 
make
make -C convertor

#	--with-system-regex \

# PostgreSQL module
gcc -shared -fPIC $RPM_OPT_FLAGS -DEAPI -DCOMPILE_DL=1 -DHAVE_PQCMDTUPLES -I. -I/usr/include/apache \
	-I/usr/include/pgsql -o pgsql.so \
	./functions/pgsql.c -lpq -lc

# IMAP module
perl -pi -e 's/HAVE_IMAP 0/HAVE_IMAP 1/g' config.h
gcc -shared -fPIC $RPM_OPT_FLAGS -DEAPI -DCOMPILE_DL=1 -I. -I/usr/include/apache \
       -I/usr/include/imap -o imap.so ./functions/imap.c \
       /usr/lib/c-client.a -lc

# LDAP module
perl -pi -e 's/HAVE_LDAP 0/HAVE_LDAP 1/g' config.h
gcc -shared -fPIC $RPM_OPT_FLAGS -DEAPI -DCOMPILE_DL=1 -I. -I/usr/include/apache \
        -o ldap.so ./functions/ldap.c -lldap -llber -lc

%if %{mysql}
# MySQL module
perl -pi -e 's/HAVE_MYSQL_H 0/HAVE_MYSQL 1/g' config.h
gcc -shared -fPIC $RPM_OPT_FLAGS -DEAPI -DCOMPILE_DL=1 -I. -I/usr/include/apache -I/usr/include/mysql \
        -o mysql.so ./functions/mysql.c -L/usr/lib/mysql -lmysqlclient -lc
%endif

%if %{ORACLE}
# ORACLE module
perl -pi -e 's/HAVE_ORACLE 0/HAVE_ORACLE 1/g' config.h
gcc -shared -fPIC $RPM_OPT_FLAGS -DEAPI -DCOMPILE_DL=1 -I. -I/usr/include/apache \
        -I%{ORACLE_HOME}/rdbms/demo \
        -I%{ORACLE_HOME}/network/public \
	-I%{ORACLE_HOME}/rdbms/public \
        -L%{ORACLE_HOME}/lib \
	-lclntsh -ldl -lm -lpthread \
        -o oracle.so ./functions/oracle.c
perl -pi -e 's/HAVE_OCI8 0/HAVE_OCI8 1/g' config.h
gcc -shared -fPIC $RPM_OPT_FLAGS -DEAPI -DCOMPILE_DL=1 -I. -I/usr/include/apache \
	-I%{ORACLE_HOME}/rdbms/demo \
	-I%{ORACLE_HOME}/network/public \
	-I%{ORACLE_HOME}/rdbms/public \
	-L%{ORACLE_HOME}/lib \
	-lclntsh -ldl -lm -lpthread \
	-o oci8.so ./functions/oci8.c
%endif

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{libdir}
mkdir -p $RPM_BUILD_ROOT/etc/httpd
mkdir -p $RPM_BUILD_ROOT/home/httpd/icons
mkdir -p $RPM_BUILD_ROOT/usr/bin
install -m 755 -s libphp3.so $RPM_BUILD_ROOT%{libdir}
install -m 644 php3.ini-dist $RPM_BUILD_ROOT/etc/httpd/php3.ini
install -m 644 %{SOURCE2} $RPM_BUILD_ROOT/home/httpd/icons
install -m 644 extra/icons/*.gif $RPM_BUILD_ROOT/home/httpd/icons
install -m 755 convertor/convertor $RPM_BUILD_ROOT/usr/bin

## install optional module
install -m 755 -s pgsql.so $RPM_BUILD_ROOT%{libdir}
install -m 755 -s imap.so $RPM_BUILD_ROOT%{libdir}
install -m 755 -s ldap.so $RPM_BUILD_ROOT%{libdir}
%if %{mysql}
install -m 755 -s mysql.so $RPM_BUILD_ROOT%{libdir}
%endif
%if %{ORACLE}
install -m 755 -s oracle.so $RPM_BUILD_ROOT%{libdir}
install -m 755 -s oci8.so $RPM_BUILD_ROOT%{libdir}
# dummy libclntsh.so.8.0
mkdir -p $RPM_BUILD_ROOT/usr/lib/
gcc -shared -Wl,-soname,libclntsh.so.8.0 %{SOURCE6} -o $RPM_BUILD_ROOT/usr/lib/libclntsh.so.8.0
%endif

mv convertor/README convertor/README.convertor

cp %{SOURCE1} .
cp %{SOURCE3} .
cp %{SOURCE4} .
cp %{SOURCE5} .

# manual
mkdir -p $RPM_BUILD_ROOT%{manualdir}
cp doc/*.html $RPM_BUILD_ROOT%{manualdir}
cd $RPM_BUILD_ROOT%{manualdir}
ln -sf manual.html index.html

%clean
rm -rf $RPM_BUILD_ROOT

%post
perl -pi -e 's|#AddType application/x-httpd-php3|AddType application/x-httpd-php3|g' /etc/httpd/conf/httpd.conf
mv -f %{libdir}/libphp3.so /tmp/libphp3.so
/usr/sbin/apxs -i -a -n "php3" /tmp/libphp3.so > /dev/null 2>&1
rm -f /tmp/libphp3.so
rm -f /etc/httpd/conf/httpd.conf.bak

%triggerin -- apache
perl -pi -e 's|#AddType application/x-httpd-php3|AddType application/x-httpd-php3|g' /etc/httpd/conf/httpd.conf
mv -f %{libdir}/libphp3.so /tmp/libphp3.so
/usr/sbin/apxs -i -a -n "php3" /tmp/libphp3.so > /dev/null 2>&1
rm -f /tmp/libphp3.so
rm -f /etc/httpd/conf/httpd.conf.bak

%postun
if [ $1 = 0 ]; then
	perl -pi -e 's|AddType application/x-httpd-php3|#AddType application/x-httpd-php3|g' /etc/httpd/conf/httpd.conf

	cat /etc/httpd/conf/httpd.conf \
	| grep -v "LoadModule php3_module" \
	| grep -v "AddModule mod_php3.c" \
	> /etc/httpd/conf/httpd.conf.fixed
	mv -f /etc/httpd/conf/httpd.conf.fixed /etc/httpd/conf/httpd.conf
fi
%post imap
perl -pi -e 's|^;extension=imap.so|extension=imap.so|g' /etc/httpd/php3.ini

%postun imap
if [ $1 = 0 ]; then
  perl -pi -e 's|^extension=imap.so|;extension=imap.so|g' /etc/httpd/php3.ini
fi

%post pgsql
perl -pi -e 's|^;extension=pgsql.so|extension=pgsql.so|g' /etc/httpd/php3.ini

%postun pgsql
if [ $1 = 0 ]; then
  perl -pi -e 's|^extension=pgsql.so|;extension=pgsql.so|g' /etc/httpd/php3.ini
fi

%post ldap
perl -pi -e 's|^;extension=ldap.so|extension=ldap.so|g'  /etc/httpd/php3.ini

%postun ldap
if [ $1 = 0 ]; then
  perl -pi -e 's|^extension=ldap.so|;extension=ldap.so|g' /etc/httpd/php3.ini
fi

%if %{mysql}
%post mysql
perl -pi -e 's|^;extension=mysql.so|extension=mysql.so|g'  /etc/httpd/php3.ini

%postun mysql
if [ $1 = 0 ]; then
  perl -pi -e 's|^extension=mysql.so|;extension=mysql.so|g' /etc/httpd/php3.ini
fi
%endif

%if %{ORACLE}
%post oracle
#perl -pi -e 's|^;extension=oracle.so|extension=oracle.so|g' /etc/httpd/php3.ini 
perl -pi -e 's|^;extension=oci8.so|extension=oci8.so|g' /etc/httpd/php3.ini
rm -f /usr/lib/libclntsh.so.8.0

%preun oracle
if [ $1 = 0 ]; then
  perl -pi -e 's|^extension=oracle.so|;extension=oracle.so|g' /etc/httpd/php3.ini
  perl -pi -e 's|^extension=oci8.so|;extension=oci8.so|g' /etc/httpd/php3.ini
  touch /usr/lib/libclntsh.so.8.0
fi
%endif

%files
%defattr(-,root,root)
%{libdir}/libphp3.so
%config /etc/httpd/php3.ini
/home/httpd/icons/*
%doc CODING_STANDARDS CREDITS ChangeLog LICENSE BUGS examples FAQ.php3
%doc INSTALL*
%doc convertor/README.convertor
%doc php3_test.php3

%files pgsql
%defattr(-,root,root)
%{libdir}/pgsql.so
%doc pg_test.php3
%doc pg_test.table

%files imap
%defattr(-,root,root)
%{libdir}/imap.so

%files ldap
%defattr(-,root,root)
%{libdir}/ldap.so

%if %{mysql}
%files mysql
%defattr(-,root,root)
%{libdir}/mysql.so
%endif

%if %{ORACLE}
%files oracle
%defattr(-,root,root)
%{libdir}/oracle.so
%{libdir}/oci8.so
/usr/lib/libclntsh.so.8.0
%endif

%files manual
%defattr(-,root,root)
%{manualdir}
